% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
function varargout = UIPanel(varargin)
% UIPANEL MATLAB code for UIPanel.fig
%      UIPANEL, by itself, creates a new UIPANEL or raises the existing
%      singleton*.
%
%      H = UIPANEL returns the handle to a new UIPANEL or the handle to
%      the existing singleton*.
%
%      UIPANEL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in UIPANEL.M with the given input arguments.
%
%      UIPANEL('Property','Value',...) creates a new UIPANEL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before UIPanel_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to UIPanel_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help UIPanel

% Last Modified by GUIDE v2.5 08-Dec-2015 16:46:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @UIPanel_OpeningFcn, ...
                   'gui_OutputFcn',  @UIPanel_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before UIPanel is made visible.
function UIPanel_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to UIPanel (see VARARGIN)

% Choose default command line output for UIPanel
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ϐ
init;

% IuWFNgnh[̓o^я
global objHandler;
global defValue;
objHandler.gcf = gcf;
objHandler.gca = findobj(objHandler.gcf,'Tag', 'axes1');
set(objHandler.gcf,'CurrentAxes', objHandler.gca);
set(objHandler.gca,'XTick',[],'YTick',[],'XTickLabel',[],'YTickLabel',[]);
set(objHandler.gca,'color',get(0,'DefaultUicontrolBackgroundColor'));
set(objHandler.gca,'Box','off','XColor','none','YColor','none');
hold on
% WCPID
tmpObjHandlerGyroP.value = findobj(objHandler.gcf, 'Tag', 'Gyro_P');
tmpObjHandlerGyroP.plus = findobj(objHandler.gcf, 'Tag', 'pb_GPP');
tmpObjHandlerGyroP.minus = findobj(objHandler.gcf, 'Tag', 'pb_GPM');
tmpObjHandlerGyroP.Reset = findobj(objHandler.gcf, 'Tag', 'pb_GPR');
objHandler.GyroP = tmpObjHandlerGyroP;
tmpObjHandlerGyroI.value = findobj(objHandler.gcf, 'Tag', 'Gyro_I');
tmpObjHandlerGyroI.plus = findobj(objHandler.gcf, 'Tag', 'pb_GIP');
tmpObjHandlerGyroI.minus = findobj(objHandler.gcf, 'Tag', 'pb_GIM');
tmpObjHandlerGyroI.Reset = findobj(objHandler.gcf, 'Tag', 'pb_GIR');
objHandler.GyroI = tmpObjHandlerGyroI;
tmpObjHandlerGyroD.value = findobj(objHandler.gcf, 'Tag', 'Gyro_D');
tmpObjHandlerGyroD.plus = findobj(objHandler.gcf, 'Tag', 'pb_GDP');
tmpObjHandlerGyroD.minus = findobj(objHandler.gcf, 'Tag', 'pb_GDM');
tmpObjHandlerGyroD.Reset = findobj(objHandler.gcf, 'Tag', 'pb_GDR');
objHandler.GyroD = tmpObjHandlerGyroD;

objHandler.GyroP.value.String = defValue.GyroP;
objHandler.GyroI.value.String = defValue.GyroI;
objHandler.GyroD.value.String = defValue.GyroD;
% ԗPID
tmpObjHandlerWheelP.value = findobj(objHandler.gcf, 'Tag', 'Wheel_P');
tmpObjHandlerWheelP.plus = findobj(objHandler.gcf, 'Tag', 'pb_WPP');
tmpObjHandlerWheelP.minus = findobj(objHandler.gcf, 'Tag', 'pb_WPM');
tmpObjHandlerWheelP.Reset = findobj(objHandler.gcf, 'Tag', 'pb_WPR');
objHandler.WheelP = tmpObjHandlerWheelP;
tmpObjHandlerWheelI.value = findobj(objHandler.gcf, 'Tag', 'Wheel_I');
tmpObjHandlerWheelI.plus = findobj(objHandler.gcf, 'Tag', 'pb_WIP');
tmpObjHandlerWheelI.minus = findobj(objHandler.gcf, 'Tag', 'pb_WIM');
tmpObjHandlerWheelI.Reset = findobj(objHandler.gcf, 'Tag', 'pb_WIR');
objHandler.WheelI = tmpObjHandlerWheelI;
tmpObjHandlerWheelD.value = findobj(objHandler.gcf, 'Tag', 'Wheel_D');
tmpObjHandlerWheelD.plus = findobj(objHandler.gcf, 'Tag', 'pb_WDP');
tmpObjHandlerWheelD.minus = findobj(objHandler.gcf, 'Tag', 'pb_WDM');
tmpObjHandlerWheelD.Reset = findobj(objHandler.gcf, 'Tag', 'pb_WDR');
objHandler.WheelD = tmpObjHandlerWheelD;

objHandler.WheelP.value.String = defValue.WheelP;
objHandler.WheelI.value.String = defValue.WheelI;
objHandler.WheelD.value.String = defValue.WheelD;
% tmpObjHandlerLightP.value = findobj(evalin('base', 'gcf0'), 'Tag', 'Light_P');
% tmpObjHandlerLightP.plus = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LPP');
% tmpObjHandlerLightP.minus = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LPM');
% tmpObjHandlerLightP.Reset = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LPR');
% objHandler.LightP = tmpObjHandlerLightP;
% tmpObjHandlerLightI.value = findobj(evalin('base', 'gcf0'), 'Tag', 'Light_I');
% tmpObjHandlerLightI.plus = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LIP');
% tmpObjHandlerLightI.minus = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LIM');
% tmpObjHandlerLightI.Reset = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LIR');
% objHandler.LightI = tmpObjHandlerLightI;
% tmpObjHandlerLightD.value = findobj(evalin('base', 'gcf0'), 'Tag', 'Light_D');
% tmpObjHandlerLightD.plus = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LDP');
% tmpObjHandlerLightD.minus = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LDM');
% tmpObjHandlerLightD.Reset = findobj(evalin('base', 'gcf0'), 'Tag', 'pb_LDR');
% objHandler.LightD = tmpObjHandlerLightD;

draw_Circle(0, 0, 10, common.colorK).fillCircle;
objHandler.Rmp = draw_Circle(0, 0, 9.7 ,common.colorDarkGray).setEdgeColor(common.colorK).fillCircle;

% --- Outputs from this function are returned to the command line.
function varargout = UIPanel_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pb_Down.
function pb_Down_Callback(hObject, eventdata, handles)
% hObject    handle to pb_Down (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global systemValue
if evalin('base', 'goBack') ~= 0
    assignin('base', 'goBack',0);
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end
assignin('base', 'goFor',0);
assignin('base', 'goBack',80);
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes on button press in pb_Left.
function pb_Left_Callback(hObject, eventdata, handles)
% hObject    handle to pb_Left (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global systemValue
if evalin('base', 'goLeft') ~= 0
    assignin('base', 'goLeft',0);    
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end
assignin('base', 'goRight',0);
assignin('base', 'goLeft',12);
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes on button press in pb_Up.
function pb_Up_Callback(hObject, eventdata, handles)
% hObject    handle to pb_Up (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global systemValue
if evalin('base', 'goFor') ~= 0
    assignin('base', 'goFor',0);
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end
assignin('base', 'goBack',0);
assignin('base', 'goFor',80);
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes on button press in pb_Right.
function pb_Right_Callback(hObject, eventdata, handles)
% hObject    handle to pb_Right (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global systemValue
if evalin('base', 'goRight') ~= 0
    assignin('base', 'goRight',0);
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end
assignin('base', 'goLeft',0);
assignin('base', 'goRight',12);
set_param(systemValue.ModelFileName,'SimulationCommand','update');



% --- Executes on button press in pb_Stay.
function pb_Stay_Callback(hObject, eventdata, handles)
% hObject    handle to pb_Stay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
assignin('base', 'goFor',0);
assignin('base', 'goLeft',0);
assignin('base', 'goRight',0);
assignin('base', 'goBack',0);
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');



function Gyro_P_Callback(hObject, eventdata, handles)
% hObject    handle to Gyro_P (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gyro_P as text
%        str2double(get(hObject,'String')) returns contents of Gyro_P as a double
assignin('base', 'GP',str2double(get(hObject,'String')));
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');


% --- Executes during object creation, after setting all properties.
function Gyro_P_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gyro_P (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_GPP.
function pb_GPP_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GPP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'GP') + defValue.GyroP/10;
assignin('base', 'GP', calcValue);
global objHandler;
objHandler.GyroP.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in pb_GPM.
function pb_GPM_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GPM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'GP') - defValue.GyroP/10;
calcValue = max(0, calcValue);
assignin('base', 'GP', calcValue);
global objHandler;
objHandler.GyroP.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in pb_GDR.
function pb_GPR_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GDR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = defValue.GyroP;
assignin('base', 'GP', calcValue);
global objHandler;
objHandler.GyroP.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


function Gyro_I_Callback(hObject, eventdata, handles)
% hObject    handle to Gyro_I (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gyro_I as text
%        str2double(get(hObject,'String')) returns contents of Gyro_I as a double
assignin('base', 'GI',str2double(get(hObject,'String')));
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes during object creation, after setting all properties.
function Gyro_I_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gyro_I (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_GIP.
function pb_GIP_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GIP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'GI') + defValue.GyroI/10;
assignin('base', 'GI', calcValue);
global objHandler;
objHandler.GyroI.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in pb_GIM.
function pb_GIM_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GIM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'GI') - defValue.GyroI/10;
calcValue = max(0, calcValue);
assignin('base', 'GI', calcValue);
global objHandler;
objHandler.GyroI.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in pb_GIR.
function pb_GIR_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GIR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = defValue.GyroI;
assignin('base', 'GI', calcValue);
global objHandler;
objHandler.GyroI.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


function Gyro_D_Callback(hObject, eventdata, handles)
% hObject    handle to Gyro_D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gyro_D as text
%        str2double(get(hObject,'String')) returns contents of Gyro_D as a double
assignin('base', 'GD',str2double(get(hObject,'String')));
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes during object creation, after setting all properties.
function Gyro_D_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gyro_D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_GDP.
function pb_GDP_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GDP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'GD') + defValue.GyroD/10;
assignin('base', 'GD', calcValue);
global objHandler;
objHandler.GyroD.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in pb_GDM.
function pb_GDM_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GDM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'GD') - defValue.GyroD/10;
calcValue = max(0, calcValue);
assignin('base', 'GD', calcValue);
global objHandler;
objHandler.GyroD.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in pb_GDR.
function pb_GDR_Callback(hObject, eventdata, handles)
% hObject    handle to pb_GDR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = defValue.GyroD;
assignin('base', 'GD', calcValue);
global objHandler;
objHandler.GyroD.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

function Wheel_P_Callback(hObject, eventdata, handles)
% hObject    handle to Wheel_P (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Wheel_P as text
%        str2double(get(hObject,'String')) returns contents of Wheel_P as a double
assignin('base', 'WP',str2double(get(hObject,'String')));
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes during object creation, after setting all properties.
function Wheel_P_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Wheel_P (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Wheel_I_Callback(hObject, eventdata, handles)
% hObject    handle to Wheel_I (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Wheel_I as text
%        str2double(get(hObject,'String')) returns contents of Wheel_I as a double
assignin('base', 'WI',str2double(get(hObject,'String')));
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes during object creation, after setting all properties.
function Wheel_I_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Wheel_I (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Wheel_D_Callback(hObject, eventdata, handles)
% hObject    handle to Wheel_D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Wheel_D as text
%        str2double(get(hObject,'String')) returns contents of Wheel_D as a double
assignin('base', 'WD',str2double(get(hObject,'String')));
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');

% --- Executes during object creation, after setting all properties.
function Wheel_D_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Wheel_D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in ch_LineTrace.
function ch_LineTrace_Callback(hObject, eventdata, handles)
% hObject    handle to ch_LineTrace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch_LineTrace
if get(hObject, 'Value') ~= evalin('base', 'EnableLineTrace');
    assignin('base', 'EnableLineTrace',get(hObject, 'Value'))
    global systemValue
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end

% --- Executes on button press in ch_CP.
function ch_CP_Callback(hObject, eventdata, handles)
% hObject    handle to ch_CP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch_CP
if get(hObject, 'Value') ~= evalin('base', 'EnableCP');
    assignin('base', 'EnableCP',get(hObject, 'Value'))
    global systemValue
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end


% --- Executes on button press in pb_WPP.
function pb_WPP_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WPP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'WP') + defValue.WheelP/10;
assignin('base', 'WP', calcValue);
global objHandler;
objHandler.WheelP.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WPM.
function pb_WPM_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WPM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'WP') - defValue.WheelP/10;
calcValue = max(0, calcValue);
assignin('base', 'WP', calcValue);
global objHandler;
objHandler.WheelP.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WIM.
function pb_WIM_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WIM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'WI') - defValue.WheelI/10;
calcValue = max(0, calcValue);
assignin('base', 'WI', calcValue);
global objHandler;
objHandler.WheelI.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WDM.
function pb_WDM_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WDM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'WD') - defValue.WheelD/10;
calcValue = max(0, calcValue);
assignin('base', 'WD', calcValue);
global objHandler;
objHandler.WheelD.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WPR.
function pb_WPR_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WPR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = defValue.WheelP;
assignin('base', 'WP', calcValue);
global objHandler;
objHandler.WheelP.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WDP.
function pb_WDP_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WDP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'WD') + defValue.WheelD/10;
assignin('base', 'WD', calcValue);
global objHandler;
objHandler.WheelD.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WIP.
function pb_WIP_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WIP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = evalin('base', 'WI') + defValue.WheelI/10;
assignin('base', 'WI', calcValue);
global objHandler;
objHandler.WheelI.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WIR.
function pb_WIR_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WIR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = defValue.WheelI;
assignin('base', 'WI', calcValue);
global objHandler;
objHandler.WheelI.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;

% --- Executes on button press in pb_WDR.
function pb_WDR_Callback(hObject, eventdata, handles)
% hObject    handle to pb_WDR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global defValue;
calcValue = defValue.WheelD;
assignin('base', 'WD', calcValue);
global objHandler;
objHandler.WheelD.value.String = calcValue;
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','update');
drawnow update;


% --- Executes on button press in ch_CS.
function ch_CS_Callback(hObject, eventdata, handles)
% hObject    handle to ch_CS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch_CS
if get(hObject, 'Value') ~= evalin('base', 'EnableCS');
    assignin('base', 'EnableCS',get(hObject, 'Value'))
    global systemValue
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end


% --- Executes on button press in pushbutton27.
function pushbutton27_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','start');

% --- Executes on button press in pushbutton28.
function pushbutton28_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global systemValue
set_param(systemValue.ModelFileName,'SimulationCommand','stop');


% --- Executes on button press in checkbox4.
function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4
% oOL/؂ւ
if get(hObject, 'Value')*2 ~= evalin('base', 'EnableCS');
    assignin('base', 'EnableCP',get(hObject, 'Value')*2)
    global systemValue
    set_param(systemValue.ModelFileName,'SimulationCommand','update');
end
