% -----------------------------------------------------------------------------------
% Copyright (c) <2016>, <Information-technology Promotion Agency, Japan>
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification,
% are permitted provided that the following conditions are met:
% 
% 1. Redistributions of source code must retain the above copyright notice,
%    this list of conditions and the following disclaimer.
% 
% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
% INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
% BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
% OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
% ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% -----------------------------------------------------------------------------------
function init
global systemValue
systemValue.ModelFileName = 'TwoWheelPendulum_NXT';
if exist(systemValue.ModelFileName) ~= 4
    % w肳ꂽt@C݂ȂA̓ft@CłȂꍇB
    systemValue.ModelFileName = bdroot;
end
assignin('base', 'EnableLineTrace',0);
assignin('base', 'EnableCP',0);
assignin('base', 'EnableCS',0);
assignin('base', 'goFor',0);
assignin('base', 'goLeft',0);
assignin('base', 'goRight',0);
assignin('base', 'goBack',0);
assignin('base', 'MoveMode',0);
global defValue;
defValue.GyroP = 0.5967;
defValue.GyroI = 0;
defValue.GyroD = 0.0491;
defValue.WheelP = 0.0146;
defValue.WheelI = 0.0078;
defValue.WheelD = 0.0192;
defValue.LightP = 6;
defValue.LightI = 0;
defValue.LightD = 0.1;
assignin('base', 'GP', defValue.GyroP);
assignin('base', 'GI', defValue.GyroI);
assignin('base', 'GD', defValue.GyroD);
assignin('base', 'WP', defValue.WheelP);
assignin('base', 'WI', defValue.WheelI);
assignin('base', 'WD', defValue.WheelD);
assignin('base', 'LP', defValue.LightP);
assignin('base', 'LI', defValue.LightI);
assignin('base', 'LD', defValue.LightD);
%ȉ͐ffW[pp[^
assignin('base', 'GP_F', defValue.GyroP);
assignin('base', 'GI_F', defValue.GyroI);
assignin('base', 'GD_F', defValue.GyroD);
assignin('base', 'WP_F', defValue.WheelP);
assignin('base', 'WI_F', defValue.WheelI);
assignin('base', 'WD_F', defValue.WheelD);
%ȉSPRTpp[^
evalin('base', 'VAR=0.1;');
evalin('base', 'STD=sqrt(VAR);');
evalin('base', 'AVR=0;');
evalin('base', 'AVR_L=1;');
evalin('base', 'AVR_H=1;');
evalin('base', 'VAR_L=0.5*VAR;');
evalin('base', 'VAR_H=2*VAR;');
evalin('base', 'fRate=0.01;');
evalin('base', 'mRate=0.001;');
evalin('base', 'A=log((1-mRate)/fRate);');
evalin('base', 'B=log(mRate/(1-fRate));');
evalin('base', 'mL=AVR-(STD*AVR_L);');
evalin('base', 'vL=VAR*VAR_L;');
evalin('base', 'mH=AVR+(STD*AVR_H);');
evalin('base', 'vH=VAR*VAR_H;');
evalin('base', 'mm=AVR;');
evalin('base', 'vv=VAR;');
assignin('base', 'rmpv', 0);
end

